// Sweep.cpp : implementation file
//

#include "stdafx.h"
#include "PeakTech_4055MV_4060.h"
#include "Sweep.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSweep dialog


CSweep::CSweep(CWnd* pParent /*=NULL*/)
	: CDialog(CSweep::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSweep)
	m_sweepStrFreq = 100.0;
	m_sweepStopFreq = 1000.0;
	m_sweepTime = 3.0;
	//}}AFX_DATA_INIT
}


void CSweep::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSweep)
	DDX_Control(pDX, IDC_SWEEP_MODE, m_comMode);
	DDX_Control(pDX, IDC_SWEEP_SOURCE, m_comSource);
	DDX_Control(pDX, IDC_SWEEP_TIME_UNIT, m_comTime);
	DDX_Control(pDX, IDC_SWEEP_STRAT_FREQ_UNIT, m_comStartFreq);
	DDX_Control(pDX, IDC_SWEEP_STOP_FREQ_UNIT, m_comStopFreq);
	DDX_Control(pDX, IDC_SWEEP_STATE, m_comOutput);
	DDX_Text(pDX, IDC_SWEEP_STAR_FREQ, m_sweepStrFreq);
	DDX_Text(pDX, IDC_SWEEP_STOP_FREQ, m_sweepStopFreq);
	DDX_Text(pDX, IDC_SWEEP_TIME, m_sweepTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSweep, CDialog)
	//{{AFX_MSG_MAP(CSweep)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSweep message handlers

BOOL CSweep::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
m_comStartFreq.SetCurSel(2);
m_comStopFreq.SetCurSel(2);
m_comTime.SetCurSel(0);
m_comSource.SetCurSel(0);
m_comOutput.SetCurSel(0);
m_comMode.SetCurSel(0);	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSweep::Send()
{
char *ptr;
	CString str,str_startFreq,str_stopFreq,str_time,str_source,str_output,str_mode;
	m_comStartFreq.GetWindowText(str_startFreq);
	m_comStopFreq.GetWindowText(str_stopFreq);
	m_comTime.GetWindowText(str_time);
	m_comSource.GetWindowText(str_source);
	m_comOutput.GetWindowText(str_output);
	m_comMode.GetWindowText(str_mode);
	ULONG len;
	ptr = (char*)malloc(1024);
	UpdateData();
	
	str.Format("SWEep:STATe %s",str_output);
	strcpy(ptr, str);
	strcat(ptr, "\n");
	len = strlen(ptr);
	CH375WriteData(0, ptr, &len);
     m_str=str + "\r\n";
	Sleep(500);
	str.Format("FREQuency:STARt %f%s",m_sweepStrFreq,str_startFreq);
	strcpy(ptr, str);
	strcat(ptr, "\n");
	len = strlen(ptr);
	CH375WriteData(0, ptr, &len);
    m_str=m_str+str + "\r\n";
	Sleep(200);
	str.Format("FREQuency:STOP %f%s",m_sweepStopFreq,str_stopFreq);
	strcpy(ptr, str);
	strcat(ptr, "\n");
	len = strlen(ptr);
	CH375WriteData(0, ptr, &len);
 m_str=m_str+str +"\r\n";
	Sleep(200);
	str.Format("SWEep:TIME %f%s",m_sweepTime,str_time);
	strcpy(ptr, str);
	strcat(ptr, "\n");
	len = strlen(ptr);
	CH375WriteData(0, ptr, &len);
 m_str=m_str+str + "\r\n";

	Sleep(100);
	str.Format("TRIGger:SOURce %s",str_source);
	strcpy(ptr, str);
	strcat(ptr, "\n");
	len = strlen(ptr);
	CH375WriteData(0, ptr, &len);
 m_str=m_str+str +"\r\n";	
	Sleep(100);
	str.Format("SWEep:SPACing %s",str_mode);
	strcpy(ptr, str);
	strcat(ptr, "\n");
	len = strlen(ptr);
	CH375WriteData(0, ptr, &len);
m_str=m_str+str +"\r\n";
    free(ptr);
}

void CSweep::OnButton1() 
{
	// TODO: Add your control notification handler code here
	    char *ptr;
	CString str;
	ULONG len;
/*	if(ch372_is_open == FALSE)
	{
		CWnd::MessageBox("ȴUSB豸", "ERROR", MB_OK);
		return;
	}*/
	ptr = (char*)malloc(1024);
	str="*TRG";
	strcpy(ptr, str);
	strcat(ptr, "\n");
	len = strlen(ptr);
	CH375WriteData(0, ptr, &len);
	m_str=str + "\r\n";
	free(ptr);	
}
